package org.etsi.mts.tdl.graphical.extensions;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.etsi.mts.tdl.Behaviour;
import org.etsi.mts.tdl.Target;
import org.etsi.mts.tdl.TestConfiguration;
import org.etsi.mts.tdl.TestDescription;

public class ModelHelper {
	public TestConfiguration getTestConfiguration(Behaviour b) {
		EObject c = b;
		while (c != null) {
			if (c instanceof TestDescription)
				return ((TestDescription) c).getTestConfiguration();
			c = c.eContainer();
		}
		return null;
	}
	
	public List<EObject> allBehaviours(TestDescription e) {
		List<EObject> behaviours = new ArrayList<EObject>();
		TreeIterator<EObject> iter = e.eAllContents();
		while (iter.hasNext()) {
			EObject c = iter.next();
			if (c instanceof Behaviour)
				behaviours.add(c);
			else if (c instanceof Target) 
				behaviours.add(c);
		}
		return behaviours;
	}
}
